/*********************************************************************************************/
/*======================== /  ATmega8=============================*/
/*********************************************************************************************/
/* 1.5
   : WinAVR-20060125
  Make: Name=muzshkat,Level=2,Debug=VMLab,Programmer=ponyser,Port=com1
        MCU=atmega8

    ATmega8:

                1 :
            CKSEL3..0 = 1100 -      0,9..3 
            SUT10=01 -  ,    

              RC-
           (CKSEL3..0 = 0001 -    RC-, 1
            SUT10=10 -   ,   )

  "0"-  !!!

   1  + 2 . =12..22

   Sound+ PORTB.1                       // - .15  (OC1A)
   Sound- PORTB.2                       // - .16  (OC1B)
*/
//
#include <avr/io.h>                          //  
#include <avr/interrupt.h>                   //   
#include <avr/pgmspace.h>                    //  
#include <avr/sleep.h>                       //   
#include <avr/eeprom.h>                      //    EEPROM
#include <melodii.h>                         //    
//
//:
#define Butt1 PD2                            //   - .4 
#define Butt2 PD3                            //  - .5 
#define Power PB0                            //  - .14 
#define Light PB3                            //  - .17 (OC2) 
//
/*----  ----*/
volatile unsigned char Play=1;               //1-, 0-
volatile unsigned char Song=0;               //  
volatile unsigned char melody_index=0;       //  
//
/*----  ----*/
void tayms (unsigned char t);                //  
//
/*----- -----*/
int main (void)
{
// 
// B
  PORTB=0b11111001;                 //PB7..PB4-. ..,PB0=1(..),PB3=1(..)
  DDRB=0b000011111;                 //PB3..PB0 - 
// D
  PORTD=0b11111111; DDRD=0b00000000;//PD7..PD0 -   ..
// C
  PORTC=0b01111111; DDRC=0x00;     //PC6..PC0 -   ..
//
  ACSR|=_BV(ACD);                  //ACSR(ACD)=1 -   
//
  unsigned char T1Reload=0;        //  (T=2*(256-XXX)/125000, F=1/T)
  unsigned char lng=0;             //  
//  
  Song=eeprom_read_byte(10);       //  EEPROM      10
  Song++;                          //  
  if (Song>=Qmel) Song=0;          // 
  eeprom_write_byte(10, Song);     //     EEPROM
//  1
  TCNT1=0;                         // ..1
  OCR1AL=Pausa;                    // 
  TCCR1B=0b00001010;               // ..1   CTC1(WGM12)=1 -   ,
                                   //F=Fclc/8=125
//   (F=976,5625/(162+1)/2=2,9955 )  8..10    ,  !!!
  OCR2=162;
  TCCR2=0b01100111;                // ..2   Fclk/1024=1/1024=976,5625,. OC2  
//
  sei();                           //  
  while(1)                         // 
  { if (Play==0)                   //  
    {
      TCCR1A=0b10100000;           //  OC1A  OC1B    ..
      OCR1AL=1;                    // OCR1AL   OCR  8 
      TCNT1=0;                     // ..1
      tayms(0);                    // 11 
      TCCR1B=0b00000000;           // ..1
      TCCR1A=0b00000000;           // OC1A  OC1B  ..1
      TCCR2=0b00000000;            // ..2,  OC2A  ..2
      melody_index=0;              //  
      PORTB=PORTB&0b11111000;      //  
      PORTB|=_BV(Light);           // 
      tayms(50);                   //     
      PORTB&=~_BV(Light);          // 
      set_sleep_mode(SLEEP_MODE_PWR_DOWN);//   Power Down
      sleep_mode();                //    (  
                                   //     Power)
      asm("nop");                  //      
      OCR1AL=Pausa;                // 
      TCCR1B=0b00001010;           // ..1   CTC1(WGM12)=1 -   ,
                                   //F=Fclc/8=125
    }
    if (melody_index<pgm_read_byte(massqmel+Song)) //       
    { switch (Song)                // 
      { case 0:                    //""
             T1Reload=pgm_read_byte(&Siren[melody_index][0]);//  
             lng=pgm_read_byte(&Siren[melody_index][1]); // 
             break;
        case 1:                    //"  (.)"
             T1Reload=pgm_read_byte(&Moment[melody_index][0]);//  
             lng=pgm_read_byte(&Moment[melody_index][1]); // 
             break;
        case 2:                    //" "
             T1Reload=pgm_read_byte(&Roman[melody_index][0]);//  
             lng=pgm_read_byte(&Roman[melody_index][1]); // 
             break;
        case 3:                    //" "
             T1Reload=pgm_read_byte(&Bank[melody_index][0]);//  
             lng=pgm_read_byte(&Bank[melody_index][1]); // 
             break;
        case 4:                    //" "
             T1Reload=pgm_read_byte(&Djen[melody_index][0]);//  
             lng=pgm_read_byte(&Djen[melody_index][1]); // 
             break;
        case 5:                    //" "
             T1Reload=pgm_read_byte(&Platoch[melody_index][0]);//  
             lng=pgm_read_byte(&Platoch[melody_index][1]); // 
             break;
        case 6:                    //""
             T1Reload=pgm_read_byte(&Kumpars[melody_index][0]);//  
             lng=pgm_read_byte(&Kumpars[melody_index][1]); // 
             break;
        case 7:                    //" "
             T1Reload=pgm_read_byte(&Slav[melody_index][0]);//  
             lng=pgm_read_byte(&Slav[melody_index][1]); // 
             break;
        case 8:                    //""
             T1Reload=pgm_read_byte(&Valenki[melody_index][0]);//  
             lng=pgm_read_byte(&Valenki[melody_index][1]); // 
             break;
        case 9:                    //" "
             T1Reload=pgm_read_byte(&Garmon[melody_index][0]);//  
             lng=pgm_read_byte(&Garmon[melody_index][1]); // 
             break;
        case 10:                   //",  "
             T1Reload=pgm_read_byte(&Kalina[melody_index][0]);//  
             lng=pgm_read_byte(&Kalina[melody_index][1]); // 
             break;
        case 11:                   //" "
             T1Reload=pgm_read_byte(&Kamysh[melody_index][0]);//  
             lng=pgm_read_byte(&Kamysh[melody_index][1]); // 
             break;
        case 12:                   //""
             T1Reload=pgm_read_byte(&Katysha[melody_index][0]);//  
             lng=pgm_read_byte(&Katysha[melody_index][1]); // 
             break;
        case 13:                   //" "
             T1Reload=pgm_read_byte(&Kazachka[melody_index][0]);//  
             lng=pgm_read_byte(&Kazachka[melody_index][1]); // 
             break;
        case 14:                   //" "
             T1Reload=pgm_read_byte(&Osen_Son[melody_index][0]);//  
             lng=pgm_read_byte(&Osen_Son[melody_index][1]); // 
             break;
        case 15:                   //" "
             T1Reload=pgm_read_byte(&Dunay[melody_index][0]);//  
             lng=pgm_read_byte(&Dunay[melody_index][1]); // 
             break;
        case 16:                   //"  "
             T1Reload=pgm_read_byte(&Manych[melody_index][0]);//  
             lng=pgm_read_byte(&Manych[melody_index][1]); // 
             break;
        case 17:                   //" "
             T1Reload=pgm_read_byte(&Koster[melody_index][0]);//  
             lng=pgm_read_byte(&Koster[melody_index][1]); // 
             break;
        case 18:                   //"  "
             T1Reload=pgm_read_byte(&More[melody_index][0]);//  
             lng=pgm_read_byte(&More[melody_index][1]); // 
             break;
        case 19:                   //""
             T1Reload=pgm_read_byte(&Polonez[melody_index][0]);//  
             lng=pgm_read_byte(&Polonez[melody_index][1]); // 
             break;
        case 20:                   //""
             T1Reload=pgm_read_byte(&Yablochko[melody_index][0]);//  
             lng=pgm_read_byte(&Yablochko[melody_index][1]); // 
             break;
        case 21:                   //""
             T1Reload=pgm_read_byte(&Cyganochka[melody_index][0]);//  
             lng=pgm_read_byte(&Cyganochka[melody_index][1]); // 
             break;
        case 22:                   //" "
             T1Reload=pgm_read_byte(&Golub_Vagon[melody_index][0]);//  
             lng=pgm_read_byte(&Golub_Vagon[melody_index][1]); // 
             break;
        case 23:                   //" "
             T1Reload=pgm_read_byte(&Star_Klen[melody_index][0]);//  
             lng=pgm_read_byte(&Star_Klen[melody_index][1]); // 
             break;
        case 24:                   //" -   "
             T1Reload=pgm_read_byte(&Ktoto[melody_index][0]);//  
             lng=pgm_read_byte(&Ktoto[melody_index][1]); // 
             break;
        case 25:                   //"   "
             T1Reload=pgm_read_byte(&Luchshe[melody_index][0]);//  
             lng=pgm_read_byte(&Luchshe[melody_index][1]); // 
             break;
        case 26:                   //""
             T1Reload=pgm_read_byte(&Murka[melody_index][0]);//  
             lng=pgm_read_byte(&Murka[melody_index][1]); // 
             break;
        case 27:                   //", "
             T1Reload=pgm_read_byte(&Parovoz[melody_index][0]);//  
             lng=pgm_read_byte(&Parovoz[melody_index][1]); // 
             break;
        case 28:                   //"  ?"
             T1Reload=pgm_read_byte(&Vinovata[melody_index][0]);//  
             lng=pgm_read_byte(&Vinovata[melody_index][1]); // 
             break;
        case 29:                   //" "
             T1Reload=pgm_read_byte(&Ryabina[melody_index][0]);//  
             lng=pgm_read_byte(&Ryabina[melody_index][1]); // 
             break;
        case 30:                   //" -"
             T1Reload=pgm_read_byte(&St_dor[melody_index][0]);//  
             lng=pgm_read_byte(&St_dor[melody_index][1]); // 
             break;
        case 31:                   //""
             T1Reload=pgm_read_byte(&Tumbalalay[melody_index][0]);//  
             lng=pgm_read_byte(&Tumbalalay[melody_index][1]); // 
             break;
        case 32:                   //" "
             T1Reload=pgm_read_byte(&Kadril[melody_index][0]);//  
             lng=pgm_read_byte(&Kadril[melody_index][1]); // 
             break;
        case 33:                   //" (  " ")"
             T1Reload=pgm_read_byte(&Stradanie[melody_index][0]);//  
             lng=pgm_read_byte(&Stradanie[melody_index][1]); // 
             break;
        case 34:                   //"Alouette (  "  ")"
             T1Reload=pgm_read_byte(&Alouette[melody_index][0]);//  
             lng=pgm_read_byte(&Alouette[melody_index][1]); // 
             break;
        case 35:                   //"  (  "")"
             T1Reload=pgm_read_byte(&Cuygan[melody_index][0]);//  
             lng=pgm_read_byte(&Cuygan[melody_index][1]); // 
             break;
        case 36:                   //"Man Of Mystery (Shadows)"
             T1Reload=pgm_read_byte(&Shadows[melody_index][0]);//  
             lng=pgm_read_byte(&Shadows[melody_index][1]); // 
             break;
      }
    }
    else Play=0;                   // -  
    if (T1Reload==Pausa)           // 
    { TCCR1A=0b10100000;           //  OC1A  OC1B  
    }
    else
    { //  
      TCNT1=0;                     // ..1
      if (T1Reload<40)             //  
      { switch (T1Reload)          // 
        { case 29: OCR1A=267;break;//  ( )  
          case 30: OCR1A=283;break;//  
          case 31: OCR1A=301;break;//  ( )  
          case 32: OCR1A=318;break;//  
          case 33: OCR1A=337;break;//   
          case 34: OCR1A=357;break;//  
          case 35: OCR1A=378;break;//  
        }
      }
      else                         //,      
      { OCR1AH=0;                  //    
        OCR1AL=T1Reload;           //  
      }
      TCCR1B=0b00001010;           // ..1   CTC1(WGM12)=1 -   ,
                                   //F=Fclc/8=125
      TCCR1A=0b01010000;           // OC1A  OC1B   ..1 ( )
      TCCR1A|=_BV(FOC1B);          //... OC1B   .
    }
    while(lng>0)                   //     
    { tayms(31);                   // 31 
      lng--;
    }
    melody_index++;                //   
    //  
    TCCR1A=0b10100000;             //  OC1A  OC1B  
    tayms(5);                      //   (   40 )
  }
}
//
/*----    (1...255)  Fclk=1----*/
void tayms (unsigned char t)
{ unsigned int t1;
  while (t!=0)
  { t1=997;
    while(--t1>0);
    t--;
  }
  return;                         // t=0  = 11 
}
//
/*
Program:     8012 bytes (97.8% Full) (8192 bytes .  ATmega8)
(.text + .data + .bootloader)

Data:          4 bytes (0.4% Full) (1024 bytes .)
(.data + .bss + .noinit)
*/
